from osv import osv,fields
from tools import configmanager
import threading
import pooler
import sql_db
from tools import config
import copy

print "===================================================="
print "RUNNING AC_PRICE_ACCURACY..."
print "===================================================="

PRICE_ACCURACY=4
price_fields={
    "account.invoice.line": ["price_unit"],
    "product.template": ["list_price","standard_price"],
    "product.product": ["price","lst_price","price_extra","price_margin"],
    "pricelist.partnerinfo": ["price"],
    "product.pricelist.item": ["price_discount"],
    "stock.move": ["price_unit"],
    "purchase.order.line": ["price_unit"],
    "sale.order.line": ["price_unit"],
}

old_db_connect=sql_db.db_connect

# set dbname in current thread, so that dbname can be known by configmanager
def new_db_connect(dbname):
    #print "=== NEW_DB_CONNECT",dbname
    db=old_db_connect(dbname)
    th=threading.current_thread()
    #print "  THREAD",th
    th.dbname=dbname
    return db

sql_db.db_connect=new_db_connect

# override price_accuracy in server config if module is installed in db
def new_getitem(self,key):
    if key=="price_accuracy":
        print "=== GET PRICE_ACCURACY"
        th=threading.current_thread()
        print "  THREAD",th
        dbname=getattr(th,"dbname",None)
        if dbname:
            print "FOUND DBNAME",dbname
            pool=pooler.get_pool(dbname)
            if "ac_price_accuracy" in pool.module_object_list:
                print "MODULE LOADED"
                return PRICE_ACCURACY
            else:
                print "MODULE NOT LOADED"
        else:
            print "NO DBNAME"
    return self.options[key]

configmanager.__getitem__=new_getitem

class price_accuracy(osv.osv):
    _name="price.accuracy"

    # modif digits of fields, not using inherit because too verbose for function fields
    def __init__(self,pool,cr):
        super(price_accuracy,self).__init__(pool,cr)
        for model,fields in price_fields.items():
            obj=pool.get(model)
            if not obj:
                print "WARNING: model %s not loaded"%model
                continue
            print "Subclassing %s..."%model
            #import pdb; pdb.set_trace()
            parent_class=obj.__class__
            new_columns=copy.copy(obj._columns) # shallow-copy columns, to avoid changing columns in other pools
            for field in fields:
                print "  overriding field",field
                new_field=copy.copy(obj._columns[field]) # shallow-copy field, to avoid changing field in other pools
                new_field.digits=(16,PRICE_ACCURACY)
                new_columns[field]=new_field
            cls=type(model,(parent_class,),{"_columns":new_columns})
            obj=object.__new__(cls)
            obj.__init__(pool,cr)
price_accuracy()
